/* 
  CPP_CONTEST=2012-CUDA
  CPP_PROBLEM=C
  CPP_LANG=CUDA1+OPENMP
*/

#include <stdlib.h>

extern void escribir(int *m, int t);

void quicksort(int *d,int izq,int der,int n)
{
  int i,j,piv,t;

  if(izq>=der)
    return;
  else
  {
    i=izq+1;
    j=der;
    piv=d[izq];
    while(i<=j)
    {
      while(i<=der && d[i]<=piv)
        i++;
      while(d[j]>piv)
        j--;
      if(i<=der && j>i)
      {
        t=d[i];
        d[i]=d[j];
        d[j]=t;
      }
    }  
    if(j>izq)
    {
      d[izq]=d[j];
      d[j]=piv;
    }
    quicksort(d,izq,j-1,n);
    quicksort(d,j+1,der,n);
  }
}

void transpose(int n,int *m,int *r)
{
  int i,j;

  for(i=0;i<n;i++)
  {
    for(j=0;j<n;j++)
    {
       r[i*n+j]=m[j*n+i];
    }
  }
}

void mmt(int t,int *a, int *r)
{
  int i, j, k,s,*at;

  at=(int *) malloc(sizeof(int)*t*t);

  transpose(t,a,at);
#ifdef DEBUG
// While debugging the transpose matrix is written
      escribir(at,t);
#endif
  for (i = 0; i < t; i++) 
  {
    for(j=0;j<t;j++)
    {
      s=0.;
      for (k = 0; k < t; k++)
	s = s+a[i*t+k]*at[j*t+k];
      r[i*t+j]=s;
    }
  }

  free(at);
}

void sort_square(int steps,int t,int *a,int node,int np)
{
  int i,*mtemp,*p;

  mtemp=(int *) malloc(sizeof(int)*t*t);

  for(i=0;i<steps;i++)
  {
    quicksort(a,0,t*t-1,t*t);
#ifdef DEBUG
// While debugging the matrix and the numbers are written
      escribir(a,t);
#endif
      mmt(t,a,mtemp);
      p=mtemp;
      mtemp=a;
      a=p;
#ifdef DEBUG
// While debugging the matrix and the numbers are written
      escribir(a,t);
#endif
  }
  if(steps%2==1)
  {
      p=mtemp;
      mtemp=a;
      a=p;
  }
  free(mtemp);
}
